Description

Lauren noticed some replica packages from urn:node:GOA on urn:node:KNB today that did not have public read allowed on their
data files. The CN also does not have public read for these data objects. | suspect that the EML <access> was updated at some
point after the package was initially saved and the CN harvested it from the GOA node. The updates to the
SystemMetadata.accessPolicy are correctly reflected on the GOA (which is the authoritative MN for these objects).

This is somewhat of a "known" issue in that SM.accessPolicy can only be updated on the CN using the CN.setAccessPolicy()
method which then calls back the all MNs that hold replicas (or originals) and informs them of the change. A long time ago we
realized that this robs the authMN of their primary authority on the object but have not been able to re-architect DataONE to support
authMN-control.

In the interim, which could be forever, we should make sure Metacat calls CN.setAccessPolicy() whenever it changes on the
authMN. Typically this will happen when parsing an updated EML file that contains additional (or fewer) access control rules but there
is also a Metacat servlet API call to set access blocks (action=setaccess, | believe).

While we can put in place code to deal with future changes to the SM.accessPolicy, we also want a mechanism for fixing the ones
that we have today. There are a couple options for that: manually with a bash script and a few curl commands, or an upgrade routine
included for the next release of Metacat that is run automatically during upgrade, or after Metacat has been completely [re]configured
as a Member Node. (There are client certificate configuration issues to think about if using an upgrade routine).

Subtasks:

Task # 6297: Create MN->CN sync script Resolved
Task # 6298: Call CN.setAccessPolicy() whenever access control rules are updated in Met... Resolved
Task # 6299: Incorporate synch script as Metacat utility or upgrade routine Resolved
Task # 6407: Add syncing test to metacat test suite Closed

Related issues:
Blocked by Metacat - Bug #6183: CNodeService API calls don't honor authoritat... Resolved

History

#1 - 12/11/2013 04:55 PM - ben leinfelder
- Description updated

- Assignee set to Peter Slaughter

#2 - 12/12/2013 01:14 PM - ben leinfelder

example package:
Original on GOA: https://goa.nceas.ucsb.edu/#view/df35d.455.4
Replica on KNB: https:/knb.ecoinformatics.org/m/#view/df35d.455.4

one of the data files on each server:
Correct on authMN: http:/goa.nceas.ucsb.edu/goa/d1/mn/v1/meta/df35d.21.2

Incorrect on CN: https://cn.dataone.org/cn/vi/meta/df35d.21.2
Incorrect of targetMN: http:/knb.ecoinformatics.org/knb/d1/mn/vi/meta/df35d.21.2

#3 - 01/30/2014 12:21 PM - ben leinfelder

- Status changed from New to In Progress

This is in progress - Peter and | have been discussing different ways access control policies can be updated on the MN using both the Metacat API
and the new DataONE MN API.

#4 - 02/21/2014 03:36 PM - ben leinfelder
- Status changed from In Progress to Closed
